---
title: JavaScript shells
slug: Web/JavaScript/Shells
tags:
  - Extensions
  - Guide
  - JavaScript
  - Tools
---
<div>{{JsSidebar}}</div>

<p>A JavaScript shell allows you to quickly test snippets of <a href="/en-US/docs/Web/JavaScript">JavaScript</a> code without having to reload a web page. They are extremely useful for developing and debugging code.</p>

<h2 id="Standalone_JavaScript_shells">Standalone JavaScript shells</h2>

<p>The following JavaScript shells are stand-alone environments, like Perl or Python.</p>

<ul>
 <li><a href="http://nodejs.org/">Node.js</a> - Node.js is a platform for easily building fast, scalable network applications.</li>
 <li><a href="https://www.graalvm.org/">GraalJS</a> - A high performance implementation of the JavaScript programming language. Built on the GraalVM by Oracle Labs.</li>
 <li><a class="external" href="http://www.jsdb.org/">JSDB</a> - A standalone JavaScript shell, with compiled binaries for Windows, Mac, and Linux.</li>
 <li><a class="external" href="http://javalikescript.free.fr/">JavaLikeScript</a> - A standalone, extensible JavaScript shell including both native and JavaScript libraries.</li>
 <li><a class="external" href="http://gluescript.sourceforge.net/">GLUEscript</a> - A standalone JavaScript shell for writing cross-platform JavaScript applications.  It can use wxWidgets for GUI apps and was formerly called wxJavaScript.</li>
 <li><a class="external" href="http://jspl.msg.mx/">jspl</a> - A standalone JavaScript shell enhanced by Perl. Can use Perl modules directly from JavaScript: DBI for database integration, GTK2 for GUI apps, POSIX for system programming, etc. The best of CPAN now for JavaScript programmers.</li>
 <li><a class="external" href="http://shelljs.org">ShellJS</a> - Portable Unix shell commands for Node.js</li>
</ul>

<h2 id="List_of_JavaScript_shells">List of JavaScript shells</h2>

<p>The following JavaScript shells work with Mozilla.</p>

<ul>
 <li>Firefox has a <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter">built-in JavaScript console</a>, which support multi-line editing.</li>
 <li><a href="/en-US/docs/Mozilla/Projects/SpiderMonkey/Introduction_to_the_JavaScript_shell">JavaScript Shell</a> (<code>js</code>) - A command line interpreter for JavaScript</li>
 <li><a href="/en-US/docs/Mozilla/XPConnect/xpcshell">xpcshell</a> is an <a href="/en-US/docs/Mozilla/Tech/XPCOM/Language_bindings/XPConnect">XPConnect</a> - enabled shell, sometimes useful for Mozilla development.</li>
 <li><a class="external" href="http://babeljs.io/repl">Babel REPL</a> - A browser-based <a href="https://en.wikipedia.org/wiki/REPL">REPL</a> for experimenting with future JavaScript.</li>
 <li><a class="external" href="http://es6console.com">ES6Console.com</a> - An open-source JavaScript console to test ECMAScript 2015 code inside the browser.</li>
 <li><a class="external" href="http://jsconsole.com/">jsconsole.com</a> -- An open-source JavaScript console with the ability to easily link to particular expressions</li>
 <li><a class="external" href="http://www.squarefree.com/shell/">JavaScript Shell (web page)</a> - also available as part of the <a class="link-https" href="https://addons.mozilla.org/en-US/firefox/addon/7434">Extension Developer's Extension</a></li>
 <li><a class="external" href="http://billyreisinger.com/jash/">Jash: JavaScript Shell</a> - a DHTML based shell that gives you command line access to a web page.</li>
 <li><a class="external" href="http://hyperstruct.net/projects/mozrepl">MozRepl</a> - Connect to Firefox and other Mozilla apps, explore and modify them from the inside, while they're running.</li>
 <li><a class="external link-https" href="https://addons.mozilla.org/en-US/firefox/addon/execute-js/">Execute JS</a> - (No longer maintained) - Firefox-Extension which provides an enhanced JavaScript-Console, where you can comfortably enter and execute arbitrary JavaScript-Code and modify functions.</li>
 <li><a class="external link-https" href="https://addons.mozilla.org/addon/159546">xqjs</a> - Simple console for Firefox.</li>
</ul>
